import * as mc from "@minecraft/server";

const validBlocks = [ "minecraft:acacia_log", "minecraft:birch_log", "minecraft:cherry_log", "minecraft:dark_oak_log", "minecraft:jungle_log", "minecraft:mangrove_log", "minecraft:oak_log", "minecraft:spruce_log", "minecraft:crimson_stem", "minecraft:warped_stem" ]; const validItems = ["minecraft:wooden_axe", "minecraft:stone_axe", "minecraft:iron_axe", "minecraft:golden_axe", "minecraft:diamond_axe", "minecraft:netherite_axe"];

mc.world.beforeEvents.playerBreakBlock.subscribe(data => { const player = data.player,block = data.block; const inventoryComponent = player.getComponent(mc.EntityInventoryComponent.componentId); const item = inventoryComponent.container.getItem(player.selectedSlotIndex); if (!validItems.includes(item?.typeId) || !validBlocks.includes(block.permutation.type.id)) return; breakNearbyLogs(block, player, block.permutation.type.id, 50); });

function breakNearbyLogs(initialBlock, player, originalBlockType, maxDepth = 5) { const visited = new Set(); function breakAndCheck(block, player, depth) { if (!block || depth > maxDepth || block.permutation.type.id !== originalBlockType) { return; } const blockKey = `${block.location.x},${block.location.y},${block.location.z}`; if (visited.has(blockKey)) { return; } visited.add(blockKey); block.dimension.runCommandAsync(`fill ${block.location.x} ${block.location.y} ${block.location.z} ${block.location.x} ${block.location.y} ${block.location.z} air destroy`); const locations = [ { x: 1, y: 0, z: 0 }, { x: -1, y: 0, z: 0 }, { x: 0, y: 1, z: 0 }, { x: 0, y: -1, z: 0 }, { x: 0, y: 0, z: 1 }, { x: 0, y: 0, z: -1 } ]; for (const pos of locations) { const adjacentBlock = block.dimension.getBlock({ x: block.location.x + pos.x, y: block.location.y + pos.y, z: block.location.z + pos.z }); breakAndCheck(adjacentBlock, player, depth + 1); } } breakAndCheck(initialBlock, player, 0); }
                          
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                                             
                                
                                
                                
                                
                                       
                                                                                                           
                                                             
                                
                                                    